#!/usr/bin/python
# -*- coding: utf-8 -*-

import os, sys, cgi, time, glob, string
import configparser

form = cgi.FieldStorage()
#GET HTTP PARAMETER
def getParameter( name ):
    if name in form:
        return form[name].value
    return ""

conf = configparser.RawConfigParser()
conf.read('/config/han2mbus.ini')
dconf = configparser.RawConfigParser()
dconf.read('/config/han2mbus_default.ini')


def getopt(cport,opt):
    retval=''
    try:
        retval=conf.get(cport,opt)
        if retval=='':
            retval=dconf.get(cport,opt)
    except:
        retval=dconf.get(cport,opt)
    return retval

baudRateList=['300','600','1200','2400','4800','9600','19200','38400']
bitList=['5','6','7','8']
parityList=[('N','No parity'),('O','Odd Parity'),('E','Even Parity'),('M','Mark Parity'),('S','Space Parity')]
stopBitList=['1','2']
meterTypeList=['Aidon','Kaifa','Kamstrup']
typeDict={'UDP':'UDP','TCP':'TCP','SER':'Serial'}
portDict={'ALL':'ALL','ETHERNET1':'ETHERNET1','ETHERNET2':'ETHERNET2','RS485':'RS-485','RS232':'RS-232','MBSLAVE1':'M-Bus Slave 1','MBSLAVE2':'M-Bus Slave 2','MBMASTER':'M-Bus Master'}
sPortDict={'UDP':{'ETHERNET1':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ETHERNET2':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ALL':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')]},
           'TCP':{'ETHERNET1':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ETHERNET2':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ALL':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')]},
           'SER':{'RS232':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'RS485':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'MBSLAVE1':[('MBUS','M-Bus')],'MBSLAVE2':[('MBUS','M-Bus')]}}

yesno=['YES','NO']

hanversion=""
try:
    mbv=os.popen("/binary/han2mbus -v")
    hanversion=mbv.read()
    mbv.close()
except:
    pass


H1metertype     = getopt('HanPort1','metertype')
H1enable        = getopt('HanPort1','enable')
H1timeout       = getopt('HanPort1','timeout')
H1porttype      = getopt('HanPort1','porttype')
H1hanlocalip    = getopt('HanPort1','localip')
H1hanlocalport  = getopt('HanPort1','localport')
H1mbuslocalip   = getopt('HanPort1','remoteip')
H1mbuslocalport = getopt('HanPort1','remoteport')
H1sercomport    = getopt('HanPort1','sercomport')
H1serbaudrate   = getopt('HanPort1','serbaudrate')
H1serbits       = getopt('HanPort1','serbits')
H1serparity     = getopt('HanPort1','serparity')
H1serstopbit    = getopt('HanPort1','serstopbit')
H1mbusprimaddr  = getopt('HanPort1','mbusprimaddr')
H1mbusid        = getopt('HanPort1','mbusid')

H2metertype     = getopt('HanPort2','metertype')
H2enable        = getopt('HanPort2','enable')
H2timeout       = getopt('HanPort2','timeout')
H2porttype      = getopt('HanPort2','porttype')
H2hanlocalip    = getopt('HanPort2','localip')
H2hanlocalport  = getopt('HanPort2','localport')
H2mbuslocalip   = getopt('HanPort2','remoteip')
H2mbuslocalport = getopt('HanPort2','remoteport')
H2sercomport    = getopt('HanPort2','sercomport')
H2serbaudrate   = getopt('HanPort2','serbaudrate')
H2serbits       = getopt('HanPort2','serbits')
H2serparity     = getopt('HanPort2','serparity')
H2serstopbit    = getopt('HanPort2','serstopbit')
H2mbusprimaddr  = getopt('HanPort2','mbusprimaddr')
H2mbusid        = getopt('HanPort2','mbusid')

MBporttype      = getopt('MBusPort','porttype')
MBtimeout       = getopt('MBusPort','timeout')
MBserver        = getopt('MBusPort','server')
MBlocalip       = getopt('MBusPort','localip')
MBlocalport     = getopt('MBusPort','localport')
MBremoteip      = getopt('MBusPort','remoteip')
MBremoteport    = getopt('MBusPort','remoteport')
MBsercomport    = getopt('MBusPort','sercomport')
MBserbaudrate   = getopt('MBusPort','serbaudrate')
MBserbits       = getopt('MBusPort','serbits')
MBserparity     = getopt('MBusPort','serparity')
MBserstopbit    = getopt('MBusPort','serstopbit')


import tenjin
from tenjin.helpers import *
tenjin.Engine.cache = tenjin.MemoryCacheStorage()
engine = tenjin.Engine()
print(engine.render('templates/han2mbus.pyhtml'))

