#!/usr/bin/python3

import sys, os
import struct
import datetime
import tenjin
from tenjin.helpers import *
import configparser

conf = configparser.RawConfigParser()
conf.read('/config/han2mbus.ini')
dconf = configparser.RawConfigParser()
dconf.read('/config/han2mbus_default.ini')

def getopt(cport,opt):
    retval=''
    try:
        retval=conf.get(cport,opt)
        if retval=='':
            retval=dconf.get(cport,opt)
    except:
        retval=dconf.get(cport,opt)
    return retval

def printData(data):
    tstr = ""
    for j in range(len(data)):
        if j&0x0f == 0 and j != 0:
            tstr += '\n'
        tstr += "%02X "%data[j]
    print(tstr)

meter1list1=[]
if os.path.isfile("/tmp/hanmodule11"):
    with open("/tmp/hanmodule11",'r') as file:
        for l in file.readlines():
            meter1list1.append(l.split(';'))
meter1list2=[]
if os.path.isfile("/tmp/hanmodule12"):
    with open("/tmp/hanmodule12",'r') as file:
        for l in file.readlines():
            meter1list2.append(l.split(';'))
meter1list3=[]
if os.path.isfile("/tmp/hanmodule13"):
    with open("/tmp/hanmodule13",'r') as file:
        for l in file.readlines():
            meter1list3.append(l.split(';'))
meter2list1=[]
if os.path.isfile("/tmp/hanmodule21"):
    with open("/tmp/hanmodule21",'r') as file:
        for l in file.readlines():
            meter2list1.append(l.split(';'))
meter2list2=[]
if os.path.isfile("/tmp/hanmodule22"):
    with open("/tmp/hanmodule22",'r') as file:
        for l in file.readlines():
            meter2list2.append(l.split(';'))
meter2list3=[]
if os.path.isfile("/tmp/hanmodule23"):
    with open("/tmp/hanmodule23",'r') as file:
        for l in file.readlines():
            meter2list3.append(l.split(';'))

H1metertype     = getopt('HanPort1','metertype')
H2metertype     = getopt('HanPort2','metertype')

tenjin.Engine.cache = tenjin.MemoryCacheStorage()
engine = tenjin.Engine()
# render template with context data
context = { 'title': 'List of Wireless Meters',
           'header': ["Description", "Value", "Unit","Obis Code"],
           'H1metertype':H1metertype,
           'H2metertype':H2metertype,
           'meter1l1': meter1list1,
           'meter1l2': meter1list2,
           'meter1l3': meter1list3,
           'meter2l1': meter2list1,
           'meter2l2': meter2list2,
           'meter2l3': meter2list3
           }
#context = { 'title': 'List of Wireless Meters',
#            'header': ["Secondary Address", "Prim Addr", "MFCT", "Meter Type", "RSSI", "Time Stamp (UTC)"],
#            'items': meterlist }
output = engine.render('templates/han2mbus_results.pyhtml', context)
print(output)
