#!/usr/bin/python3

import os, sys, cgi
import tempfile
import subprocess

form = cgi.FieldStorage()
#GET HTTP PARAMETER
def getParameter( name ):
    if name in form:
        return form[name].value
    return ""

host = getParameter("server_ip")
fingerprint = getParameter("server_fingerprint")
fingerprinttype=""
if len(fingerprint) > 0:
    if fingerprint.split(':')[0] == 'SHA256':
        fingerprinttype = 'sha256'
    else:
        fingerprint = 'MD5:' + fingerprint
        fingerprinttype = 'md5'

fd, path = tempfile.mkstemp()
with os.fdopen(fd, 'w') as tmp:
    cmd = 'ssh-keyscan -H ' + host + ' > ' + path + ' 2> /dev/null'
    os.system(cmd)
    #process = subprocess.Popen(cmd.split(' '), universal_newlines=True, stdout=tmp)
    #ret_code = process.wait()
    tmp.flush()
    tmp.close()

rep = os.system("ping  -c 1 %s &> /dev/null"%host)
filename = "/config/ssh/known_hosts"
if rep == 0: # Host did answer
    if fingerprint != '':
        #print("%s"%fingerprint)
        out = ""
        if fingerprinttype == 'md5':
            #print("Server fingerprint:")
            out = subprocess.check_output(["ssh-keygen", "-l", "-E","md5", "-f","%s"%path],stderr=None).decode("utf-8")
            #os.system("ssh-keygen -l -E md5 -f %s 2> /dev/null"%path)
            #print(out)
        elif fingerprinttype == 'sha256':
            #print("Server fingerprint:")
            out = subprocess.check_output(["ssh-keygen", "-l", "-E","sha256", "-f","%s"%path],stderr=None).decode("utf-8")
            #os.system("ssh-keygen -l -E sha256 -f %s 2> /dev/null"%path)
            #print(out)
        else:
            pass
            #print("No fingerprint to show")
        if out != "":
            correct=False
            sps = out.split("\n")
            for s in sps:
                if len(s.split(" ")) > 1:
                    server_fingerprint=s.split(" ")[1]
                    #print("Server fingerprint = %s"%server_fingerprint)
                    if fingerprint == server_fingerprint:
                        #print("Server verified.")
                        f = open(filename,'w')
                        f.write("#comment;%s;Host Key OK, Verified\n"%host)
                        f.flush()
                        f.close()
                        os.system("cat %s >> %s;sync"%(path,filename))
                        correct = True
                        break
            if not correct:
                #print("Server verification failed")
                f = open(filename,'w')
                f.write("#comment;%s;Host Key Not added, Verification Failed\n"%host)
                f.flush()
                f.close()
                #os.system("sync;cat %s >> %s"%(path,filename))
    else:
        #print("Host key added but not verified.")
        f = open(filename,'w')
        f.write("#comment;%s;Host Key OK, Warning! Unverified\n"%host)
        f.flush()
        f.close()
        os.system("cat %s >> %s;sync"%(path,filename))
#else:
#    #print("Unknown host")
#    f.write("#comment;%s;No Host Key. Unknown Host"%host)
#    f.flush()
#    f.close()
    #os.system("cat %s >> %s;sync"%(path,filename))

print("""<HTML>
    <HEAD>
        Writing conf file
        <meta http-equiv=\"refresh\" content=\"0;url=/cgi-bin/quickpostSecurity.py\">
    </HEAD>
</HTML>""")
