#!/usr/bin/python
# -*- coding: utf-8 -*-

import os, sys, cgi, time, glob, string
import configparser

form = cgi.FieldStorage()
#GET HTTP PARAMETER
def getParameter( name ):
    if name in form:
        return form[name].value
    return ""

conf = configparser.RawConfigParser()
conf.read('/config/wireless.ini')
dconf = configparser.RawConfigParser()
dconf.read('/config/wireless_default.ini')


def getopt(cport,opt):
    retval=''
    try:
        retval=conf.get(cport,opt)
        if retval=='':
            retval=dconf.get(cport,opt)
    except:
        retval=dconf.get(cport,opt)
    return retval

wirelessModeDict={'0':'S2','1':'T1','3':'S1','11':'T1+C'}
baudRateList=['300','600','1200','2400','4800','9600','19200','38400']
bitList=['5','6','7','8']
parityList=[('N','No parity'),('O','Odd Parity'),('E','Even Parity'),('M','Mark Parity'),('S','Space Parity')]
stopBitList=['1','2']
ipLocalList=['ALL','ETHERNET1','ETHERNET2']

typeDict={'UDP':'UDP','TCP':'TCP','SER':'Serial'}
portDict={'ALL':'ALL','ETHERNET1':'ETHERNET1','ETHERNET2':'ETHERNET2','RS485':'RS-485','RS232':'RS-232','MBSLAVE1':'M-Bus Slave 1','MBSLAVE2':'M-Bus Slave 2'}
mPortDict={'UDP':{'ALL':[('MBUS','M-Bus')]},'TCP':{'ALL':[('MBUS','M-Bus')]},'SER':{'RS232':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'RS485':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')]}}
sPortDict={'UDP':{'ETHERNET1':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ETHERNET2':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ALL':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')]},
           'TCP':{'ETHERNET1':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ETHERNET2':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ALL':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')]},
           'SER':{'RS232':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'RS485':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'MBSLAVE1':[('MBUS','M-Bus')],'MBSLAVE2':[('MBUS','M-Bus')]}}
mProtocolDict={'MBUS':'M-Bus'}
yesno=['YES','NO']

wlversion=""
fabnum=""
try:
    mbv=os.popen("/binary/wireless -v")
    wlversion=mbv.read().strip()
    mbv.close()
    mbv=os.popen("/binary/wireless -S")
    fabnum=mbv.read().strip()
    mbv.close()
except:
    pass


primaryaddress = getopt('Main','primaryaddress')
wirelessmode   = getopt('Main','wirelessmode')
telegram_preserve_time = getopt('Main','telegram_preserve_time')
if not (wirelessmode in wirelessModeDict.keys()):
    wirelessmode = '10'
enable_leds     = getopt('Main','enable_leds')
telegram_log    = getopt('Main','telegram_log')
#enable_inclexcl = getopt('Main','enable_inclexcl')
include_file    = getopt('Main','include_file')
exclude_file    = getopt('Main','exclude_file')

Stimeout     = getopt('SlavePort','timeout')
Sporttype    = getopt('SlavePort','porttype')
Slocalip     = getopt('SlavePort','localip')
Slocalport   = getopt('SlavePort','localport')
Sremoteip    = getopt('SlavePort','remoteip')
Sremoteport  = getopt('SlavePort','remoteport')
Ssercomport  = getopt('SlavePort','sercomport')
Sserbaudrate = getopt('SlavePort','serbaudrate')
Sserbits     = getopt('SlavePort','serbits')
Sserparity   = getopt('SlavePort','serparity')
Sserstopbit  = getopt('SlavePort','serstopbit')

csvfileArray=glob.glob("/config/[wW][iI][rR][eE][lL][eE][sS][sS]*.[cC][sS][vV]")
for i in range(len(csvfileArray)):
    csvfileArray[i] = csvfileArray[i][8:] #Error when doing strip("/config/")

import tenjin
from tenjin.helpers import *
tenjin.Engine.cache = tenjin.MemoryCacheStorage()
engine = tenjin.Engine()
print(engine.render('templates/wireless.pyhtml'))

